/** 
 * @Version $Rev: 95 $
 * @Author M.Sekido
 * @Date  $Date: 2014-04-23 20:27:53 +0900 (Wed, 23 Apr 2014) $
 * $Id: Mk5B_Header.cpp 95 2014-04-23 11:27:53Z vlbi $ 
 */


#include "Mk5B_Header.hpp"

//======= Mk5B libraries ==== from here ======

// int32_t  Mk5B_Hdr::Hd_find(const uint8_t*  buf, const uint32_t nbyte){
//   uint32_t remain = nbyte;
//   int find_flag=0; 
//   uint8_t *pb = (uint8_t* )buf;

//   uint32_t hdsize = Headsize();
//   int32_t count=0;

//   while( remain >= hdsize && find_flag==0){
//     pt_head = (Mk5B_Hdr*)pb;
//     if( pt_head->sync_word == 0xABADDEED ){
//       find_flag =1;
//       memcpy(&head_buf[0], pt_head, Headsize());
//       return( count);
//     }else{
//       pb++; count++; remain--;
//     }
//   } // end while 
//   pt_head=0;
//   return(-1);
// }


Time_dat Mk5B_Hdr::Epoch(){
  
  time_t t0 = time(0);
  struct tm tm0; 
  gmtime_r(&t0,&tm0);
  Time_dat t1(tm0.tm_year+1900, tm0.tm_mon+1, tm0.tm_mday, 0,0,0);

  //double mjd_now = tm2mjd(tm0);
  double mjd_now = t1.Mjd();
  double mjd_tmp = (double)(mjd2*10 + mjd1)*10 + mjd0;
  double mjd = (int)floor(mjd_now/ 1000)*1000 + mjd_tmp;
  double dt = (mjd - mjd_now)*86400.;
  
  double sod = (((s4*10+s3)*10+s2)*10+s1) *10 +s0;
  sod+=   (((ms4*0.1 + ms3)*0.1 + ms2)*0.1 + ms1)*0.1;
//   mjd += sod/86400.;
//   t1.Set_time(mjd);
   t1 += (dt + sod);

  return t1;
}

// void Mk5B_Hdr::Print_hd(FILE *fp){
//   fprintf(fp, "- Mk5B HD info : ");
//   //  fprintf(fp," Epoch-sec = %d/%d %d sec\n", year, doy, sod);
//   fprintf(fp," Epoch = %s ", Epoch().Print_time(20).c_str());
//   if(tvg_flag) fprintf(fp,"TVG: ON  "); 
//   else                  fprintf(fp,"TVG: OFF "); 
//   fprintf(fp, " iframes=%d \n", iframe);
//   //  fprintf(fp,"----------------------------\n");
// }

string Mk5B_Hdr::Str_hd(void){
    char buf[256];
  sprintf(buf,"ifrm=%5d Epoch:%s,", iframe,Epoch().Print_time(10).c_str());
  string str(buf);
  if(tvg_flag) sprintf(buf,"TVG: ON"); 
  else         sprintf(buf,"TVG:OFF"); 
  str += buf;
  return str;
}


Mk5B_Hdr*   Mk5B_Hdr_find(const uint8_t*  buf, 
			  const uint32_t nbyte, long& offset){
  uint32_t remain = nbyte;
  int find_flag=0; 
  uint8_t *pb = (uint8_t* )buf;

  Mk5B_Hdr *pt_head(0); 
  uint32_t hdsize = pt_head->Headsize();
  int32_t count=0;


  while( remain >= hdsize && find_flag==0){
    pt_head = (Mk5B_Hdr*)pb;
    //    if( pt_head->sync_word == 0xABADDEED ){
    if( pt_head->HD_Match() ){
      find_flag =1;
      //      memcpy(&head_buf[0], pt_head, Headsize());
      offset=count;
      return( pt_head);
    }else{
      pb++; count++; remain--;
    }
  } // end while 
  //  pt_head=0;
  return(0);
}


const bool  Mk5B_Hdr_find(FILE *fp, long& offset, Mk5B_Hdr& head){

  int32_t count=0;
  int32_t hdsize = head.Headsize();
  int bufsize = hdsize * 10;
  uint8_t buf[bufsize];
  Mk5B_Hdr* phead = (Mk5B_Hdr*)buf;;

  while( feof(fp) ==0 ){
    int nread = fread(buf,bufsize,1,fp);
    char *pb = (char*)buf;
    if( nread <1) break;
    
    for(int i=0; i<bufsize; i++){
      phead = (Mk5B_Hdr*)pb;
      //    if(dbg_disp_level>10) pt_head->Disp();
      if( phead->sync_word == 0xABADDEED){
	head = *phead;
	offset=count;
	fseek(fp,i-bufsize,SEEK_CUR);  // rewind to head pos.
	return(true);
      }else{
	count++;  pb++;
      }
    }
  } // end while 

  return (false);
}

void Mk5B_Hdr::Set_header(Time_dat& t1){
  sync_word = 0xABADDEED;
  user_dat = 0xF00F;
  double mjd = t1.Mjd();
  int intmjd = (int)floor(mjd);
  int secmjd = (int)floor((mjd-intmjd)*86400+5e-7);

  mjd2 = (intmjd%1000/100);
  mjd1 = ((intmjd%100)/10);
  mjd0 = (intmjd%10);
   
  s4 = (secmjd/10000)&0xF;
  s3 = ((secmjd%10000)/1000)&0xF;
  s2 = ((secmjd%1000)/100)&0xF;
  s1 = ((secmjd%100)/10)&0xF;
  s0 = (secmjd%10)&0xF;
  double sec = t1.Sec();
  int fracsec = (int)((sec - floor(sec))*10000);
  
  ms4 = fracsec/1000;
  ms3 = (fracsec%1000)/100;
  ms2 = (fracsec%100)/10;
  ms1 = fracsec%10;
  
  // unsigned char crcdata[6];
  // crcdata[0] = mjd2<<4|mjd1;
  // crcdata[1] = mjd0<<4|s4;
  // crcdata[2] = s3<<4|s2;
  // crcdata[3] = s1<<4|s0;
 
  // crcdata[4] = ms4<<4|ms3;
  // crcdata[5] = ms2<<4|ms1;

  //  iframe ++;
  
  //  uint16_t crc = pCRC_mdl->Cmp_CRC(crcdata,6);
  // *crc = reversebits16(crcc(crcdata, 48, 040003, 16));
  //  printf("Header = {%08x,%08x,%08x,%08x}\n",header[0],header[1],header[2],header[3]);

}

//======= Mk5B libraries ==== to here ======
